<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow  xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   xmlns:componente="br.com.desenv.framework.componente.*"
			   close="titlewindowCloseHandler(event)"  
			   creationComplete="creationCompleteHandler(event)" 
			   title="Cadastro de ParametroSistema"
			  maxWidth="1200" maxHeight="700"  
			   xmlns:visual="br.com.desenv.framework.component.visual.*"  >
			   
	<fx:Style source="../../../framework/util/estilo.css"/>

	
	
	<fx:Metadata>
		[Event(name="ParametroSistemaIncluidoEvent")]
		[Event(name="ParametroSistemaAtualizadoEvent")]
		[Event(name="ParametroSistemaExcluidoEvent")]
		[Event(name="ParametroSistemaSelecionadoEvent")]
		
	</fx:Metadata>

	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.controls.DateField;
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.validators.Validator;
			import spark.events.TitleWindowBoundsEvent;
			
			import br.com.desenv.nepalign.vo.ParametroSistema;
			
			import br.com.desenv.nepalign.vo.EmpresaFisica;
			// Alguem passa a objeto para ca
			public var parametroSistema : ParametroSistema = new ParametroSistema();
			
			[Bindable]
			private var listaEmpresaFisica: ArrayCollection = new ArrayCollection();

			
			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			
			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}
			
			private function limparListaCampo(): void
			{
				ignTextInputChave.text = "";
				ignTextAreaValor.text = "";
				ignTextInputDescricao.text = "";
// Combo
				ignComboBoxAutoCompleteEmpresaFisica.selectedIndex = -1;
			}
			
			// Chama ao completar o carregamento da pagina
			private function creationCompleteHandler( event: FlexEvent ): void 
			{
				carregarListaValidacao();
				
				var remoteObjectEmpresaFisica: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("empresaFisicaService", listarEmpresaFisicaResultHandler);	
				remoteObjectEmpresaFisica.getOperation("listar").send();
				
				// Se e um novo cadastro
				if (isNaN(this.parametroSistema.id))
				{
					limparListaCampo();
				}
				// Se alguem passou o objeto
				else
				{
					ignTextInputChave.text = this.parametroSistema.chave;

					ignTextAreaValor.text = this.parametroSistema.valor;

					ignTextInputDescricao.text = this.parametroSistema.descricao;

					//ignComboBoxAutoCompleteEmpresaFisica.selectedItem = this.parametroSistema.empresaFisica;
				}
			}
			
			private function listarEmpresaFisicaResultHandler( event: ResultEvent ): void 
			{
				listaEmpresaFisica = event.result as ArrayCollection;
				listaEmpresaFisica.addItemAt(null, 0);
				
				if (this.parametroSistema != null && this.parametroSistema.empresaFisica != null)
				{
					for(var i:int = 1; i <= this.listaEmpresaFisica.length; i++)
					{
						var empresaFisicaTemp: EmpresaFisica = this.listaEmpresaFisica.getItemAt(i) as EmpresaFisica;
						
						if (empresaFisicaTemp.id == this.parametroSistema.empresaFisica.id)
						{
							ignComboBoxAutoCompleteEmpresaFisica.selectedIndex = i;
							break;
						}
					}
				}	
			}
			
			
			
			// Chama quando fecha a janela no X
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- SALVAR E ATUALIZAR  --------------------------------	
			private function buttonSalvar_clickHandler( event: MouseEvent ): void 
			{
				if (validar(event))
				{
					// Se e alteracao
					if (isNaN(parametroSistema.id) == false) 
					{
						parametroSistema.chave = ignTextInputChave.text;
						parametroSistema.valor = ignTextAreaValor.text;
						parametroSistema.descricao = ignTextInputDescricao.text;
						parametroSistema.empresaFisica = ignComboBoxAutoCompleteEmpresaFisica.selectedItem; 
						var remoteObjectAtualizar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("parametroSistemaService", atualizarResultHandler);	
						remoteObjectAtualizar.getOperation("atualizar").send(parametroSistema); 
					// Se e inclusao
					} 
					else 
					{
						parametroSistema.chave = ignTextInputChave.text;

						parametroSistema.valor = ignTextAreaValor.text;

						parametroSistema.descricao = ignTextInputDescricao.text;

						parametroSistema.empresaFisica = ignComboBoxAutoCompleteEmpresaFisica.selectedItem; 
						var remoteObjectSalvar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("parametroSistemaService", salvarResultHandler);	
						remoteObjectSalvar.getOperation("salvar").send(parametroSistema); 
					}
				}	
			}

			
			// Depois que salva fecha a janela
			private function salvarResultHandler( event: ResultEvent ): void 
			{
				this.parametroSistema = event.result as ParametroSistema;
				this.dispatchEvent(new ResultEvent("ParametroSistemaIncluidoEvent",false, true, this.parametroSistema, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			// Depois que atualiza fecha a janela
			private function atualizarResultHandler( event: ResultEvent ): void 
			{
				this.parametroSistema = event.result as ParametroSistema;
				this.dispatchEvent(new Event("ParametroSistemaAtualizadoEvent"));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- LIMPAR  --------------------------------	
			protected function buttonLimpar_clickHandler(event:MouseEvent):void
			{
				limparListaCampo();
			}
						
// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				
			protected function buttonAdicionarEmpresaFisica_clickHandler(event:MouseEvent):void
			{
				var empresaFisicaComponenteCadastro: EmpresaFisicaComponenteCadastro = new EmpresaFisicaComponenteCadastro();
				empresaFisicaComponenteCadastro.addEventListener("EmpresaFisicaIncluidoEvent", atualizarListaEmpresaFisicaPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(empresaFisicaComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(empresaFisicaComponenteCadastro);
			}
			
			private function atualizarListaEmpresaFisicaPorInclusaoResultHandler(e:ResultEvent):void
			{
				var novoEmpresaFisica: EmpresaFisica = e.result as EmpresaFisica;
				listaEmpresaFisica.addItem(novoEmpresaFisica);
				ignComboBoxAutoCompleteEmpresaFisica.selectedItem = novoEmpresaFisica;
			}

			
// ---------------------------------- PESQUISAR AUTOR ABRINDO A LISTA  --------------------------------				
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<!-- <mx:Validator id="validatorObrigatorioSituacaoParametroSistema" property="selectedItem" required="true" source="{comboBoxSituacaoParametroSistema}" trigger="{comboBoxSituacaoParametroSistema}" triggerEvent="valueCommit"/> -->
		
	</fx:Declarations>
	

	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="720" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Chave:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoChave" styleName="labelValidacao" text="{ignTextInputChave.errorString}"/>
					<visual:IgnTextInput id="ignTextInputChave" maxChars="100" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Valor:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoValor" styleName="labelValidacao" text="{ignTextAreaValor.errorString}"/>
					<visual:IgnTextArea id="ignTextAreaValor" width="100%" heightInLines="5" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Descrição:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoDescricao" styleName="labelValidacao" text="{ignTextInputDescricao.errorString}"/>
					<visual:IgnTextInput id="ignTextInputDescricao" maxChars="45" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="EmpresaFisica:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoEmpresaFisica" styleName="labelValidacao" text="{ignComboBoxAutoCompleteEmpresaFisica.errorString}"/>
					<s:HGroup>
						<visual:IgnComboBoxAutoComplete id="ignComboBoxAutoCompleteEmpresaFisica" dataProvider="{listaEmpresaFisica}" labelField="razaoSocial" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
						<s:Button id="buttonAdicionarEmpresaFisica" width="30" label="+" click="buttonAdicionarEmpresaFisica_clickHandler(event)"/>
					</s:HGroup>
				</s:VGroup>
			</mx:GridItem>		



		</mx:GridRow>		
		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Button id="buttonSalvar" label="Salvar" click="buttonSalvar_clickHandler(event)"/>
				<s:Button id="buttonLimpar" label="Limpar" click="buttonLimpar_clickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
	</mx:Grid>
</s:TitleWindow>